Const QUALITY_POOR:Int 	= 1
Const QUALITY_COMMON:Int 	= 2
Const QUALITY_UNCOMMON:Int = 3
Const QUALITY_RARE:Int	= 4
Const QUALITY_EPIC:Int	= 5
Const QUALITY_LEGENDARY:Int	= 6

Type TItem
	
	Global Inventory:TList = CreateList()
	Global BackPack:TList = CreateList()
	
	Field Name:String, Quality:Int, Stacks:Int, ItemID:Int
	
	Function Create:TItem( N:String, I:Int, Q:Int, S:Int )
		
		Local A:TItem = New TItem
			A.Name = N
			A.ItemID = I
			A.Quality = Q
			A.Stacks = S
			Return( A )
		
	End Function
	
	Function LoadAll( Path:String, List:TList )
		If FileType( Path ) = FILETYPE_FILE
			Local File:TStream = ReadFile( Path )
				While Not Eof( File )
					Local Name:String = ReadLine( File )
					Local Quality:Int = Int( ReadLine( File ) )
					Local ItemID:Int = Int( ReadLine( File ) )
					Local Stacks:Int = Int( ReadLine( File ) )
					List.Addlast( TItem.Create( Name, ItemID, Quality, Stacks ) )
					ReadLine( File )
				Wend
			CloseFile( File )
		EndIf
		TItemsTab.UpdateItemList()
	End Function
	
	Function SaveAll( Path:String, FromList:TList )
		
		Local File:TStream = WriteFile( Path )
			For Local A:TItem = EachIn FromList
				
				WriteLine( File, A.Name )
				WriteLine( File, A.Quality )
				WriteLine( File, A.ItemID )
				WriteLine( File, A.Stacks )
				WriteLine( File, "" )
			Next
		CloseFile( File )
		
	End Function
	
	Function Compile()
		Local Line:String
		Local File:TStream = WriteFile( "Compiled.ini" )
			For Local A:TItem = EachIn TItem.Inventory
				
				'Name
				Select A.Quality
					Case QUALITY_POOR
						Line = "|9d9d9d|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:80|h[" + A.Name + "]|h|r"
					Case QUALITY_COMMON
						Line = "|cffffffff|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:80|h[" + A.Name + "]|h|r"
					Case QUALITY_UNCOMMON
						Line = "|cff1eff00|Hitem:" + A.ItemID + ":0:0:0:0:0:0:0:80|h[" + A.Name + "]|h|r"
					Case QUALITY_RARE
						Line = "|cff0070dd|Hitem:" + A.itemID + ":0:0:0:0:0:0:0:80|h[" + A.Name + "]|h|r"
					Case QUALITY_EPIC
						Line = "|cffa335ee|Hitem:"+A.ItemID+ ":0:0:0:0:0:0:0:80|h[" + A.Name + "]|h|r"
					Case QUALITY_LEGENDARY
						Line = "|cffe6cc80|Hitem:" + A.ItemID + ":0:0:0:0:0:0:0:80|h[" + A.Name + "]|h|r"
				End Select
				
				Line = "[" + Chr(34) + "info" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'ItemID
				Line = A.ItemID
				Line = "[" + Chr(34) + "id" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'Stacks
				Line = A.Stacks
				Line = "[" + Chr(34) + "count" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'ItemID 2
				Line = A.ItemID
				Line = "[" + Chr(34) + "id" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				'Stacks
				Line = A.Stacks
				Line = "[" + Chr(34) + "count" + Chr(34 ) + "] = " + Chr( 34 ) + Line + Chr( 34 ) + ","
				WriteLine( File, Line )
				
				WriteLine( File, "" )
			Next
		CloseFile( File )
	End Function
	
End Type