Type TItemsTab
	
	Global Parent:TGadget
	Global Child:TGadget[10]
	Global Font:TGuiFont = LoadGuiFont( "Ariel", 12, True, False, False, False )
	
	Function Create:Int()
		
		Parent = TMainWindow.Child[0]
		Local WW:Int = ClientWidth( Parent )
		Local WH:Int = ClientHeight( Parent )
		
		Child[0] = CreateLabel( "", 5, 5, WW - 10, 25, Parent, LABEL_CENTER )
		SetGadgetColor( Child[0], 0, 0, 0 )
		SetGadgetFont( Child[0], Font )
		
		Child[1] = CreateTextField( 5, 35, WW - 160, 25, Parent )
		
		Child[3] = CreateTextField( 5, 65, 100, 25, Parent )
		Child[4] = CreateTextField( 5, 95, 100, 25, Parent )
		
		Child[7] = CreateLabel( "Item ID", 110, 70, 50, 25, Parent )
		Child[5] = CreateLabel( "Stacks", 110, 100, 50, 25, Parent )
		
		Child[6] = CreateListBox( 5, 125, WW-10, WH - 160, Parent )
		
		Child[2] = CreateComboBox( WW - 150, 35, 140, 25, Parent )
		AddGadgetItem( Child[2], "Item Quality" )
		AddGadgetItem( Child[2], "Poor" )
		AddGadgetItem( Child[2], "Common" )
		AddGadgetItem( Child[2], "Uncommon" )
		AddGadgetItem( Child[2], "Rare" )
		AddGadgetItem( Child[2], "Epic" )
		AddGadgetItem( Child[2], "Legendary" )
		
		Child[8] = CreateButton( "Create", 185, 65, 200, 55, Parent )
		Child[9] = CreateComboBox( 5, WH - 30, WW - 10, 25, Parent )
		AddGadgetItem( Child[9], "Inventory" )
		AddGadgetItem( Child[9], "Backpack" )
		SelectGadgetItem( Child[9], 0 )
		
		ResetForm()
		Hide()
	End Function
	
	Function Hide()
		For Local X:Int = 0 To 9
			HideGadget( Child[X] )
			DisableGadget( Child[X] )
		Next
	End Function
	
	Function Show()
		For Local X:Int = 0 To 9
			ShowGadget( Child[X] )
			EnableGadget( Child[X] )
		Next
	End Function
	
	Function ResetForm()
		SelectGadgetItem( Child[2], 0 )
		SetGadgetText( Child[0], "{Item Name}" )
		SetGadgetColor( Child[0], 255, 0, 0, False )
		SetGadgetText( Child[1], "" )
		SetGadgetText( Child[3], "" )
		SetGadgetText( Child[4], "1" )
	End Function
	
	Function Update()
		Select EventID()	
			Case EVENT_GADGETSELECT
				Select EventSource()
					Case Child[6]
						If EventData() = -1
							ResetForm()
						EndIf	
				End Select		
			Case EVENT_GADGETACTION
				Select EventSource()
					Case Child[1]
						If GadgetText( Child[1] ) = ""
							SetGadgetText( Child[0], "{Item Name}" )
						Else
							SetGadgetText( Child[0], GadgetText( Child[1] ) )
						EndIf
					
					Case Child[2]
						If GadgetText( Child[1] ) = ""
							SetGadgetText( Child[0], "{Item Name}" )
						Else
							SetGadgetText( Child[0], GadgetText( Child[1] ) )
						EndIf
						Select EventData()
							Case 0
								SetGadgetColor( Child[0], 255, 0, 0, False )
							Case 1
								SetGadgetColor( Child[0], 157, 157, 157, False )
							Case 2
								SetGadgetColor( Child[0], 255, 255, 255, False )
							Case 3
								SetGadgetColor( Child[0], 30, 255, 0, False )
							Case 4
								SetGadgetColor( Child[0], 0, 112, 221, False )
							Case 5
								SetGadgetColor( Child[0], 163, 53, 238, False )
							Case 6
								SetGadgetColor( Child[0], 255, 128, 0, False )
						End Select
						
					Case Child[8]
						If SelectedGadgetItem( Child[9] ) = 0
							TItem.Inventory.Addlast( TItem.Create( GadgetText( Child[1] ), Int(GadgetText( Child[3] ) ), SelectedGadgetItem( Child[2] ), Int(GadgetText( Child[4] )) ) )
						Else
							TItem.BackPack.Addlast( TItem.Create( GadgetText( Child[1] ), Int(GadgetText( Child[3] ) ), SelectedGadgetItem( Child[2] ), Int(GadgetText( Child[4] )) ) )
						EndIf
						UpdateItemList()
						ResetForm()
						
					Case Child[6]
						If EventData() => 0
							UpdateForm( TItem(EventExtra()) )
						EndIf
						
					Case Child[9]
						UpdateItemList()
						ResetForm()
						
				End Select
		End Select
	End Function
	
	Function UpdateItemList()
		Local A:TItem
		ClearGadgetItems( Child[6] )
		If SelectedGadgetItem( Child[9] ) = 0
			For A = EachIn TItem.Inventory
				AddGadgetItem( Child[6], A.Name, 0, -1, "", A )
			Next
		Else
			For A = EachIn TItem.Backpack
				AddGadgetItem( Child[6], A.Name, 0, -1, "", A )
			Next
		EndIf
		
	End Function
	
	Function UpdateForm( Item:TItem )
		SetGadgetText( Child[1], Item.Name )
		SelectGadgetItem( Child[2], Item.Quality )
		SetGadgetText( Child[3], Item.ItemID )
		SetGadgetText( Child[4], Item.Stacks )
		EmitEvent( CreateEvent( EVENT_GADGETACTION, Child[2], Item.Quality ) )
	End Function
	
End Type