
Type TRepTab
	
	Global Parent:TGadget
	Global Child:TGadget[7]
	Global Font:TGuiFont = LoadGuiFont( "Ariel", 12, True, False, False, False )
	
	Function Create()
		
		Parent = TMainWindow.Child[0]
		Local WW:Int = ClientWidth( Parent )
		Local WH:Int = ClientHeight( Parent )
		
		Child[0] = CreateLabel( "", 5, 5, WW - 10, 25, Parent, LABEL_CENTER )
		SetGadgetColor( Child[0], 255, 255, 255, False )
		SetGadgetColor( Child[0], 0, 0, 0 )
		SetGadgetFont( Child[0], Font )
		
		Child[1] = CreateTextField( 5, 35, 200, 25, Parent )
		Child[2] = CreateLabel( "Name", 210, 40, 50, 25, Parent )
		
		Child[3] = CreateTextField( 5, 65, 200, 25, Parent )
		Child[4] = CreateLabel( "Value", 210, 70, 50, 25, Parent )
		
		Child[5] = CreateListBox( 5, 100, WW - 10, WH - 105, Parent )
		Child[6] = CreateButton( "Create", 270, 35, 120, 55, Parent )
		
		ResetForm()
		Hide()
	End Function
	
	Function Update()
		
		Select EventID()
			
			Case EVENT_GADGETACTION
				Select EventSource()
					
					Case Child[1]
						UpdateLabel()
					
					Case Child[3]
						UpdateLabel()
					
					Case Child[5]
						UpdateForm( TReputation( EventExtra() ) )
						
					Case Child[6]
						TReputation.Create( GadgetText( Child[1] ), Int( GadgetText( Child[3] ) ) )
						UpdateList()
						ResetForm()
				End Select
			
		End Select
		
	End Function
	
	Function UpdateForm( A:TReputation )
		
		SetGadgetText( Child[1], A.Name )
		SetGadgetText( Child[3], A.Value )
		UpdateLabel()
		
	End Function
	
	Function UpdateLabel()
		
		If GadgetText( Child[1] ) <> ""
			If GadgetText( Child[3] ) <> ""
				SetGadgetText( Child[0], GadgetText( Child[1] ) + ", " + GadgetText( Child[3] ) )
			Else
				SetGadgetText( Child[0], "{Faction, Value}" )
			EndIf
		Else
			SetGadgetText( Child[0], "{Faction, Value}" )
		EndIf
		
	End Function
	
	Function ResetForm()
		SetGadgetText( Child[1], "" )
		SetGadgetText( Child[3], "" )
		UpdateLabel()
	End Function
	
	Function Hide()
		For Local X:Int = 0 To 6
			HideGadget( Child[X] )
			DisableGadget( Child[X] )
		Next
	End Function
	
	Function Show()
		For Local X:Int = 0 To 6
			ShowGadget( Child[X] )
			EnableGadget( Child[X] )
		Next
	End Function
	
	Function UpdateList()
		
		If CountList( TReputation.List ) > 0
			ClearGadgetItems( Child[5] )
			For Local A:TReputation = EachIn TReputation.List
				AddGadgetItem( Child[5], A.Name, 0, -1, "", A )
			Next
		EndIf
				
	End Function
	
End Type
